import type { Middleware } from '@floating-ui/dom';
import type { MiddlewareState } from '@floating-ui/dom';

export declare type Data = MiddlewareData | TriggerData;

export declare namespace FloatingUI {
    export type MiddlewareData = Omit<MiddlewareState, 'platform'> & {
        type: 'FloatingUIMiddleware';
    };
}

export declare namespace FluentUI {
    export type MiddlewareData = {
        type: 'FluentUIMiddleware';
        options: object;
        middlewareState: Omit<MiddlewareState, 'platform'>;
        placement: {
            position: string;
            alignment?: string;
        };
        initialPlacement: {
            position: string;
            alignment?: string;
        };
        flipBoundaries: HTMLElement[];
        overflowBoundaries: HTMLElement[];
        scrollParents: HTMLElement[];
    };
    export type TriggerData = {
        type: 'FluentUITrigger';
    };
}

export declare const middleware: (targetDocument: Document, middlewareDataCallback?: (state: MiddlewareState) => MiddlewareData) => Middleware;

export declare type MiddlewareData = FloatingUI.MiddlewareData | FluentUI.MiddlewareData;

export declare type TriggerData = FluentUI.TriggerData;

export { }
